﻿using System;
using System.Linq;
using System.Reflection;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using BillAnalyserWebApp.Code.Data;
using CrossCompileSharing.Data;

namespace BillAnalyserWebApp
{
	[ServiceContract(Namespace = "iFlexAbonentsService")]
	[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class AbonentsService
	{
		[OperationContract]
		public ServiceResult<List<Abonent>> GetAbonents()
		{
			return Abonents.AbonentsGet();
		}

		[OperationContract]
		public ServiceResult<List<Abonent>> GetAbonentGroups()
		{
			return Abonents.AbonentGroupsGet();
		}

		[OperationContract]
		public ServiceResult<List<Abonent>> GetAbonentGroupsWithCompensation(long idCompensation)
		{
			return Abonents.AbonentGroupsGetWithCompensation(idCompensation);
		}

		[OperationContract]
		public ServiceResult<List<Phone>> GetPhonesByAbonent(long idAbonent)
		{
			return Phones.UserPhones(idAbonent);
		}


	}
}