﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!



using System;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using BillAnalyserWebApp.Code.Data;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using Oracle.DataAccess.Client;

namespace BillAnalyserWebApp
{
	[ServiceContract(Namespace = "iFlexBillService")]
	[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class BillsService
	{
		[OperationContract]
		public ServiceResult<List<Bill>> GetBills(DateTime? period, string filter, bool isPhone, long? abonentid)
		{
			return Bills.BillGet(period, filter, isPhone, abonentid);
		}

		[OperationContract]
		public ServiceResult<List<BillService>> GetBillService(Int64? idBill, Int64? idPhone)
		{
			return BillServices.BillServicesGet(idBill, idPhone);
		}

		[OperationContract]
		public ServiceResult<List<Bill>> GetBillCharges(DateTime? period, string filter, bool isPhone, long? abonentid)
		{
			return Bills.BillChargesGet(period, filter, isPhone, abonentid);
		}

		[OperationContract]
		public ServiceResult<List<BillService>> GetBillChargesService(Int64? idBill, Int64? idPhone)
		{
			return BillServices.BillChargesServicesGet(idBill, idPhone);
		}

		#region UpdateSumDed

		//    ba_bill_charges_iapi.upd_sum_ded ( i_id in number, i_summ in number);
		//где, 
		//            i_id              ИД начисления
		//            i_summ            Сумма

		[OperationContract]
		public ServiceResult<Boolean> UpdateSumDed(Int64 billChargesId, double newValueDed)
		{
			var command = new OracleCommand("ba_bill_charges_iapi.upd_sum_ded") { CommandType = System.Data.CommandType.StoredProcedure };
			command.Parameters.Add("i_id", OracleDbType.Int64, billChargesId, System.Data.ParameterDirection.Input);
			command.Parameters.Add("i_summ", OracleDbType.Double, newValueDed, System.Data.ParameterDirection.Input);

			return OracleDbPull.ExecuteNonQuery<Boolean>(
			command,
			serviceResult =>
			{
				serviceResult.DataOrNullOrDefValue = true;
			}
			);
		}
		#endregion 
	}
}