﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!

using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Класс опиывающий абонента...
	/// Функционал пересекается с OrgUnit, но нет времени переделывать  
	/// </summary>
	[Obfuscation(Exclude = true)]
	public class Abonent
	{
		/// <summary>
		/// Идентификатор абонента
		/// </summary>
		public Int64 Id { get; set; }

		/// <summary>
		/// Идентификатор родителя. null - для корневых элементов
		/// </summary>
		public Int64? ParentId { get; set; }

		/// <summary>
		/// ФИО для абонента и название для группы
		/// </summary>
		public String Name { get; set; }

		/// <summary>
		/// Группа(подразделение) - истина, абонент - ложь
		/// </summary>
		public Boolean IsGroup { get; set; }

		/// <summary>
		/// Должность
		/// </summary>
		public String Appointment { get; set; }

		/// <summary>
		/// Почтовый адресс
		/// </summary>
		public String Email { get; set; }

		/// <summary>
		/// Роль в системе
		/// </summary>
		public Int32? RoleId { get; set; }

		/// <summary>
		/// Какой-то тип
		/// </summary>
		public Int32? ExportType { get; set; }

		/// <summary>
		/// Код по 1С
		/// </summary>
		public String Code1C { get; set; }

		/// <summary>
		/// Учетная запись
		/// </summary>
		public String Login { get; set; }

		/// <summary>
		/// Пароль
		/// </summary>
		public String Password { get; set; }

		/// <summary>
		/// 1 - значит у всех абонентов в группе проставлен чекбокс
		/// -1 - ни уодного не проставлен
		/// 0 - частично проставлен
		/// </summary>
		public short Checked  { get; set; }

		/// <summary>
		/// true - значит у всех абонентов в группе проставлен чекбокс
		/// false - ни уодного не проставлен
		/// null - частично проставлен
		/// </summary>
		public bool? HasChild { get; set; }

	}
}