﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!


using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Класс описывающий услугу или агрегат...
	/// </summary>
	[Obfuscation(Exclude = true)]
	public class AggService
	{
		/// <summary>
		/// идентификатор услуги
		/// </summary>
		public Int64? IdService { get; set; }

		/// <summary>
		/// идентификатор агрегата
		/// </summary>
		public Int64? IdAgg { get; set; }

		/// <summary>
		/// Название услуги/агрегата
		/// </summary>
		public String Name { get; set; }

		/// <summary>
		/// true - агрегат
		/// false - услуга
		/// </summary>
		public bool IsAgg { get; set; }

		/// <summary>
		/// идентификатор единицы измерения
		/// </summary>
		public Int64? IdUnit { get; set; }

		/// <summary>
		/// название единицы измерения
		/// </summary>
		public String NameUnit { get; set; }

		/// <summary>
		/// Маска
		/// </summary>
		public String Mask { get; set; }

		/// <summary>
		/// Маска
		/// </summary>
		public String Dsc { get; set; }

		/// <summary>
		/// Флаг выделенного
		/// </summary>
		public bool IsSelected { get; set; }

		/// <summary>
		/// Список дочерних услуг
		/// </summary>
		public List<AggService> ChildServices;
	}

	[Obfuscation(Exclude = true)]
	public class ServiceMoveInfo
	{
		public long id_service;
		public long id_source_agg;
		public long id_target_agg;
	}
}