using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using Oracle.DataAccess.Client;
using CrossCompileSharing.UiStrings;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Summary description for 
	/// </summary>
	public static class AggUnits
	{
		#region AggUnitsGet

		internal static ServiceResult<List<AggUnit>> AggUnitsGet()
		{
			//    
			const string sql = "SELECT ID, NAME from v_ba_units";
			var oCom = new OracleCommand(sql);

			return OracleDbPull.GetDataTable<List<AggUnit>>(
				oCom,
				(resultDataTable, serviceResult) =>
				{
					var unitRaw = (
						from row in resultDataTable.AsEnumerable()
						select new
						{
							ID = (Int64)row.Field<Decimal>("ID"),
							NAME = row.Field<String>("NAME"),
						}
						).ToList();

					var units = new List<AggUnit>();

					foreach (var row in unitRaw)
					{
						var agg = new AggUnit { Id = row.ID, Name = row.NAME };
						units.Add(agg);
					}

					serviceResult.DataOrNullOrDefValue = units;
				}
				);
		}

		#endregion
	}
}