

//  it3xl.ru  .



using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using iFlexBillAnalyserResources.Data;
using Oracle.DataAccess.Client;

namespace BillAnalyserWebApp.Code.Data
{
	public static class AllBillingPeriods
	{
		public static ServiceResult<List<BillingPeriod>> GetAllBillingPeriods()
		{
			var oCom = new OracleCommand(@"
select t.period_name, t.bill_date from v_used_periods t order by t.bill_date desc
");
			return OracleDbPull.GetDataTable<List<BillingPeriod>>(
				oCom,
				(resultDataTable, serviceResult) =>
				{
					serviceResult.DataOrNullOrDefValue =
						(
						from row in resultDataTable.AsEnumerable()
						select new BillingPeriod()
						{
							Name = row.Field<String>("period_name"),
							Date = row.Field<DateTime>("bill_date"),
						}
						).ToList();
				}
				);
		}
	}
}