﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!



using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Класс описывающий счет...
	/// </summary>
	[Obfuscation(Exclude = true)]
	public class Bill
	{
		/// <summary>
		/// идентификатор счета
		/// </summary>
		public Int64 BillId { get; set; }

		/// <summary>
		/// идентификатор телефона
		/// </summary>
		public Int64 PhoneId { get; set; }

		/// <summary>
		/// телефон
		/// </summary>
		public String Phone { get; set; }

		/// <summary>
		/// Идентификатор абонента
		/// </summary>
		public Int64? AbonentId { get; set; }

		/// <summary>
		/// Имя абонента
		/// </summary>
		public String Abonent { get; set; }

		/// <summary>
		/// Начислено (удержано)
		/// </summary>
		public double? Charge { get; set; }

		/// <summary>
		/// Компенсировано.
		/// </summary>
		public double? Compensated { get; set; }

		/// <summary>
		/// Удержано
		/// </summary>
		public string Retantion { get; set; }

		/// <summary>
		/// Номер счета
		/// </summary>
		public String BillNumber { get; set; }

		/// <summary>
		/// Дата счета
		/// </summary>
		public String BillDate { get; set; }

		/// <summary>
		/// Идентификатор по которому будем менять запись
		/// </summary>
		public Int64 BillChargesId { get; set; }

		/// <summary>
		/// Свойство для редактирвоания поля "Удержания"
		/// </summary>
		public bool IsReadOnly { get; set; }

		/// <summary>
		/// Свойство для отображения/скрытия кнопки "Отм."
		/// </summary>
		public bool IsVisibleCancel { get; set; }

	}
}