﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!



using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Globalization;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Summary description for CommonFunctions
	/// </summary>
	public sealed class CommonFunctions
	{
		#region Функция выполняет нормализацию числа
		/// <summary>
		/// Функция выполняет нормализацию числа 
		/// (замена запятых и точек на текущий десятичный разделитель
		/// для возможности ввода в кач-ве разделителя и точек и запятых)
		/// </summary>
		/// <param name="ps_value">число в виде строки</param>
		/// <returns>нормализованное число</returns>
		public static string NormFloat(string value)
		{
			//Результат преобразования
			string res = value;

			//Объект для получения символов разделителей
			NumberFormatInfo nfi = NumberFormatInfo.CurrentInfo;

			//Заменяем запятые на разделитель десятичных разрядов для системы
			res = res.Replace(",", nfi.NumberDecimalSeparator);

			//Заменяем точки на разделитель десятичных разрядов для системы
			res = res.Replace(".", nfi.NumberDecimalSeparator);

			if (res.IndexOf(nfi.NumberDecimalSeparator) != res.LastIndexOf(nfi.NumberDecimalSeparator))
				res = String.Empty;

			return res;
		}
		#endregion

		#region Функция возвращает истину если строка подходит по формату для почтового адреса
 
		/// <summary>
		/// Функция возвращает истину если строка подходит по формату для почтового адреса
		/// </summary>
		/// <param name="text"></param>
		/// <returns></returns>
		public static bool IsEmail(String text)
		{
			if (text == null || text.IndexOf(' ', 0) != -1)
			{
				// Не может быть почтовым адресом
				return false;
			}

			if (text.IndexOf("@") > 0)
			{
				// Первый признак почтового адреса
				int pos = text.LastIndexOf('.');
				String domen = text.Substring(pos, text.Length - pos - 1);

				if (domen.Length >= 2)
					return true;
				else
					return false;
			}

			return false;

		}
		#endregion
	}
}