﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!


using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Класс опиывающий привязку компенсацию по абоненту...
	/// </summary>
	[Obfuscation(Exclude = true)]
	public class CompensationOfAbonent
	{
		/// <summary>
		/// Идентификатор абонента
		/// </summary>
		public Int64 ID { get; set; }

		/// <summary>
		/// ФИО для абонента и название для группы
		/// </summary>
		public String Name { get; set; }

		/// <summary>
		/// Телефон
		/// </summary>
		public String Phone { get; set; }

		/// <summary>
		/// Идентфикатор телефона
		/// </summary>
		public Int64? PhoneId { get; set; }

		//public List<PhoneNullable> Phones { get; set; }

		/// <summary>
		/// Идентификатор группы
		/// </summary>
		public Int64? GroupId { get; set; }

		/// <summary>
		/// true - группа, false - абонент
		/// </summary>
		public bool IsGroup { get; set; }

		/// <summary>
		/// Идентификатор лимиты
		/// </summary>
		public Int64? CompensationId { get; set; }

		/// <summary>
		/// Идентификатор привязки лимиты по телефону
		/// </summary>
		public Int64? CompensaionPhoneId { get; set; }

		/// <summary>
		/// Флаг установленной лимиты 
		/// </summary>
		public bool IsComp { get; set; }

		/// <summary>
		/// Флаг для фильтрации абонентов при формировании "чистого" списка.
		/// true - абонент(телефон) обработан, false - еще нет
		/// </summary>
		public bool IsProcessed { get; set; }
	}

	[Obfuscation(Exclude = true)]
	public class CompensationOfAbonentResult
	{
		public string abonent { get; set; }
		public string phone { get; set; }
	}
}