//   .             !


using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using Oracle.DataAccess.Client;
using CrossCompileSharing.UiStrings;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Summary description for Abonents
	/// </summary>
	public static class CompensationsOfAbonents
	{
		#region       

		internal static ServiceResult<List<CompensationOfAbonent>> CompensationsOfAbonentsGet(Int64 idCompensation)
		{
			const string sql = (@"
                    select g.*,
                    decode (g.comp_id, :idCompensation,1,0) is_comp 
                    from v_ba_phone_comp_grid g
                    ");

			var oCom = new OracleCommand(sql) { CommandType = CommandType.Text };

			oCom.Parameters.Add("idCompensation", OracleDbType.Int64, idCompensation, System.Data.ParameterDirection.Input);
			//oCom.Parameters.Add("selectedGroupId", OracleDbType.Int64, idGroup, System.Data.ParameterDirection.Input);

			return OracleDbPull.GetDataTable<List<CompensationOfAbonent>>(
				oCom,
				(resultDataTable, serviceResult) =>
				{
					var phonesOfAbonentsRaw = (
						from row in resultDataTable.AsEnumerable()
						select new
						{
							ID = (Int64)row.Field<Decimal>("ID"),
							Name = row.Field<String>("NAME"),
							Phone = row.Field<String>("PHONE"),
							PhoneId = (Int64?)row.Field<Decimal?>("PHONE_ID"),
							GroupId = (Int64?)row.Field<Decimal?>("GROUP_ID"),
							IsGroup = row.Field<Int16?>("IS_GROUP") == 1,
							CompId = (Int64?)row.Field<Decimal?>("COMP_ID"),
							CompsPhoneId = (Int64?)row.Field<Decimal?>("PHONE_COMPS_ID"),
							IsComp = row.Field<Decimal>("IS_COMP") == 1,
						}
						).ToList();

					var abonentsWithoutDup = new List<CompensationOfAbonent>();

					foreach (var row in phonesOfAbonentsRaw)
					{
						var a = new CompensationOfAbonent { ID = row.ID, Name = row.Name, IsGroup = row.IsGroup, GroupId = row.GroupId };

						a.IsGroup = row.IsGroup;
						a.CompensationId = row.CompId;
						a.CompensaionPhoneId = row.CompsPhoneId;
						a.IsComp = row.IsComp;
						a.IsProcessed = false;

						if (a.IsGroup == false)
						{
							a.PhoneId = row.PhoneId;
							a.Phone = row.Phone;
						}

						abonentsWithoutDup.Add(a);
					}

					serviceResult.DataOrNullOrDefValue = abonentsWithoutDup;
				}
				);
		}

		#endregion
	}
}