﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	[Obfuscation(Exclude = true)]
	public class DataForPost
	{
		public Int64 AbonentId { get; set; }

		public String Abonent { get; set; }

		public DateTime period { get; set; }

		public List<DataForPostByPhone> lists { get; set; }

		public double Charge
		{
			get
			{
				double result = 0;
				foreach (var data_by_phone in lists)
				{
					result += data_by_phone.Charges;
				}
				return result;
			}
		}

		public double Compensation
		{
			get
			{
				double result = 0;
				foreach (var data_by_phone in lists)
				{
					result += data_by_phone.Compensation;
				}
				return result;
			}
		}

		public double Retantion
		{
			get
			{
				double result = 0;
				foreach (var data_by_phone in lists)
				{
					result += data_by_phone.Retantion;
				}
				return result;
			}
		}
	}

	[Obfuscation(Exclude = true)]
	public class DataForPostByPhone
	{
		/// <summary>
		/// Иденитификатор телефона
		/// </summary>
		public Int64 phoneId { get; set; }

		/// <summary>
		/// Номер телефона
		/// </summary>
		public String Phone { get; set; }

		/// <summary>
		/// Детализация услуг
		/// </summary>
		public List<Call> listCalls { get; set; }

		/// <summary>
		/// по агрегатам услуг
		/// </summary>
		public List<BillService> listServices { get; set; }

		/// <summary>
		/// Начислено компанией (сумма по всем услугам)
		/// </summary>
		public double Charges
		{
			get
			{
				double charge = 0;
				foreach (var service in listServices)
				{
					charge += service.SumAdd.HasValue ? service.SumAdd.Value : 0.0;
				}

				return charge;
			}
		}

		/// <summary>
		/// Компенсировано компанией
		/// </summary>
		public double Compensation
		{
			get
			{
				double comp = 0;
				foreach (var service in listServices)
				{
					comp += service.SumComp.HasValue ? service.SumComp.Value : 0.0;
				}

				return comp;
			}
		}

		/// <summary>
		/// Удержано компанией
		/// </summary>
		public double Retantion
		{
			get
			{
				double ded = 0;
				foreach (var service in listServices)
				{
					ded += service.SumDed.HasValue ? service.SumDed.Value : 0.0;
				}

				return ded;
			}
		}

		/// <summary>
		/// проверка правильности расчета
		/// </summary>
		public bool Validation
		{
			get
			{
				if ((Charges - Compensation) != Retantion)
					return false;
				else
					return true;
			}
		}
	}
}