﻿using System;
using System.Reflection;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	/// Новик Н. Структура отчета о результатах импорта сотрудников
	/// </summary>
	[Obfuscation(Exclude = true)]
	public class ImportEmployeesReport
	{
		/// <summary>
		/// Номер по порядку
		/// </summary>
		public Int64 N { get; set; }
		/// <summary>
		/// Признак группы: 1-группа, 0-сотрудник
		/// </summary>
		public String isGroup { get; set; }
		/// <summary>
		/// Имя группы или ФИО
		/// </summary>
		public String Name { get; set; }
		/// <summary>
		/// Должность
		/// </summary>
		public String Post { get; set; }
		/// <summary>
		/// Телефон
		/// </summary>
		public String Phone { get; set; }
		/// <summary>
		/// E-mail 
		/// </summary>
		public String Email { get; set; }

		public String UserLogin { get; set; }
		public String UserPassword { get; set; }
		public String CostCenter { get; set; }
		public String ArbitraryParameter1 { get; set; }
		public String ArbitraryParameter2 { get; set; }
		public String ArbitraryParameter3 { get; set; }
		public String ArbitraryParameter4 { get; set; }
		public Int32? LimitRuble { get; set; }
		public Int32? LimitPercent { get; set; }

		/// <summary>
		/// Код (идентификатор во внешней системе)
		/// </summary>
		public String Code { get; set; }
		/// <summary>
		/// Код родителя
		/// </summary>
		public String ParentCode { get; set; }
		/// <summary>
		/// Описание результата импорта
		/// </summary>
		public String Dsc { get; set; }
		/// <summary>
		/// ID записи в БД
		/// </summary>
		public String Id { get; set; }
	}
}