﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using CrossCompileSharing.Log;
using CrossCompileSharing.UiStrings;
using Oracle.DataAccess.Client;

namespace BillAnalyserWebApp.Code.Data
{
	public static class ImportFilesServices
	{
		internal static ServiceResult<Int64> GetImportKey()
		{
			var command = new OracleCommand("ba_bill_services_iapi.get_import_key") { CommandType = CommandType.StoredProcedure };

			var resultParametrName = "l_res";
			command.Parameters.Add(resultParametrName, OracleDbType.Int64, ParameterDirection.ReturnValue);

			return OracleDbPull.ExecuteNonQuery<Int64>(
				command,
				serviceResult =>
				{
					try
					{
						serviceResult.DataOrNullOrDefValue = (Int64)command.Parameters[resultParametrName].Value;
					}
					catch (Exception ex)
					{
						Logger.Write(ex);
						serviceResult.BusinessErrorNotNulled.Add(UiMessages.Ошибка_приведения_полученного_значения);
					}
				}
				);
		}
	}
}