using System;
using CrossCompileSharing.Data;

namespace BillAnalyserWebApp.Code.Data
{
	/// <summary>
	///   .<para/>
	///       UI  ,  .
	/// </summary>
	public static class Protocols
	{
		private static string _currentProtocol = "";
		private static System.IO.StreamWriter _swProtocol = null;
		private static int countAnnonoim = 0;
		/// <summary>
		///      "protocol_{ }"
		/// </summary>
		public static void CreateProtocol(Int64 id)
		{
			CloseProtocol();

			if (System.IO.File.Exists(_currentProtocol))
			{
				System.IO.File.Delete(_currentProtocol);
			}

			if (id == 0)
			{
				//   
				// ITretykaov > Akotov: ,  ? :)
				_currentProtocol = System.IO.Path.GetTempPath() + "protocol_annnonim_" + countAnnonoim++ + ".log";
			}
			else
			{
				_currentProtocol = System.IO.Path.GetTempPath() + "protocol_" + id + ".log";
			}

			_swProtocol = new System.IO.StreamWriter(_currentProtocol);
		}

		public static ServiceResult<Boolean> CloseProtocol()
		{
			if (_swProtocol != null)
			{
				AddRecord("     .");
				_swProtocol.Close();
				_swProtocol = null;
			}

			return new ServiceResult<bool> { DataOrNullOrDefValue = true, };
		}

		public static void AddRecord(string record)
		{
			if (_swProtocol == null)
				return;
			DateTime dt = DateTime.Now;
			string record_to_protocol = string.Format("{0} - {1}", dt.ToShortTimeString(), record);
			_swProtocol.WriteLine(record_to_protocol);
		}
	}
}