/// <summary>
/// Tuzova L. Summary description for ReportByDetailes
/// </summary>

using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using Oracle.DataAccess.Client;

namespace BillAnalyserWebApp.Code.Data
{
	public class ReportByDetails
	{
		internal static ServiceResult<ReportByEmp> ReportByDetailGetting(Int64? depGroupID, String accGroupID, Int64? subsID, DateTime? startDate, DateTime? endDate, String startTime, String endTime, String dayOfWeek, Boolean? justWeekend, Dictionary<String, String> listColumns)
		{
			#region ReportByEmpGettingMethod

			/* Get group IDs */
			String _accGroupID = accGroupID;
			Int64? _depGroupID = depGroupID;

			/* Variables */
			var _listColumn = listColumns;
			var _subsID = subsID;

			var _startDate = startDate;
			var _endDate = endDate;

			String _dayOfWeek = dayOfWeek;

			String dateStart = String.Format("{0:dd.MM.yyyy}", _startDate);
			String dateEnd = String.Format("{0:dd.MM.yyyy}", _endDate);

			/* Add ID column to column list */
			listColumns.Add("service_type", "ServiceType");
			listColumns.Add("sum_add", "ServiceSum");
			listColumns.Add("ABONENT_ID", "DetailesID");

			String startDoW = "1";
			String endDoW = "7";

			//All days
			if (dayOfWeek.Equals(" "))
			{
				if (justWeekend == true)
				{
					startDoW = "6";
					endDoW = "7";
				}
				else
				{
					startDoW = "1";
					endDoW = "7";
				}
			}
			// Defined day
			else
			{
				if (dayOfWeek.Equals(""))
				{
					startDoW = "1";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "2";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "3";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "4";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "5";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "6";
				}
				else if (dayOfWeek.Equals(""))
				{
					startDoW = "7";
				}

				endDoW = startDoW;
			}

			/* Define time parameters */
			Int32 timeStart = 1;
			Int32 timeEnd = 24;

			/* Whole day */
			if (startTime.Equals("00:00") && endTime.Equals("00:00"))
			{
				timeStart = 0;
				timeEnd = 24;
			}
			/* Defined time period */
			else
			{
				if (startTime.Equals("01:00"))
				{
					timeStart = 1;
				}
				else if (startTime.Equals("02:00"))
				{
					timeStart = 2;
				}
				else if (startTime.Equals("03:00"))
				{
					timeStart = 3;
				}
				else if (startTime.Equals("04:00"))
				{
					timeStart = 4;
				}
				else if (startTime.Equals("05:00"))
				{
					timeStart = 5;
				}
				else if (startTime.Equals("06:00"))
				{
					timeStart = 6;
				}
				else if (startTime.Equals("07:00"))
				{
					timeStart = 7;
				}
				else if (startTime.Equals("08:00"))
				{
					timeStart = 8;
				}
				else if (startTime.Equals("09:00"))
				{
					timeStart = 9;
				}
				else if (startTime.Equals("10:00"))
				{
					timeStart = 10;
				}
				else if (startTime.Equals("11:00"))
				{
					timeStart = 11;
				}
				else if (startTime.Equals("12:00"))
				{
					timeStart = 12;
				}
				else if (startTime.Equals("13:00"))
				{
					timeStart = 13;
				}
				else if (startTime.Equals("14:00"))
				{
					timeStart = 14;
				}
				else if (startTime.Equals("15:00"))
				{
					timeStart = 15;
				}
				else if (startTime.Equals("16:00"))
				{
					timeStart = 16;
				}
				else if (startTime.Equals("17:00"))
				{
					timeStart = 17;
				}
				else if (startTime.Equals("18:00"))
				{
					timeStart = 18;
				}
				else if (startTime.Equals("19:00"))
				{
					timeStart = 19;
				}
				else if (startTime.Equals("20:00"))
				{
					timeStart = 20;
				}
				else if (startTime.Equals("21:00"))
				{
					timeStart = 21;
				}
				else if (startTime.Equals("22:00"))
				{
					timeStart = 22;
				}
				else if (startTime.Equals("23:00"))
				{
					timeStart = 23;
				}
				else if (startTime.Equals("00:00"))
				{
					timeStart = 0;
				}

				if (endTime.Equals("01:00"))
				{
					timeEnd = 1;
				}
				else if (endTime.Equals("02:00"))
				{
					timeEnd = 2;
				}
				else if (endTime.Equals("03:00"))
				{
					timeEnd = 3;
				}
				else if (endTime.Equals("04:00"))
				{
					timeEnd = 4;
				}
				else if (endTime.Equals("05:00"))
				{
					timeEnd = 5;
				}
				else if (endTime.Equals("06:00"))
				{
					timeEnd = 6;
				}
				else if (endTime.Equals("07:00"))
				{
					timeEnd = 7;
				}
				else if (endTime.Equals("08:00"))
				{
					timeEnd = 8;
				}
				else if (endTime.Equals("09:00"))
				{
					timeEnd = 9;
				}
				else if (endTime.Equals("10:00"))
				{
					timeEnd = 10;
				}
				else if (endTime.Equals("11:00"))
				{
					timeEnd = 11;
				}
				else if (endTime.Equals("12:00"))
				{
					timeEnd = 12;
				}
				else if (endTime.Equals("13:00"))
				{
					timeEnd = 13;
				}
				else if (endTime.Equals("14:00"))
				{
					timeEnd = 14;
				}
				else if (endTime.Equals("15:00"))
				{
					timeEnd = 15;
				}
				else if (endTime.Equals("16:00"))
				{
					timeEnd = 16;
				}
				else if (endTime.Equals("17:00"))
				{
					timeEnd = 17;
				}
				else if (endTime.Equals("18:00"))
				{
					timeEnd = 18;
				}
				else if (endTime.Equals("19:00"))
				{
					timeEnd = 19;
				}
				else if (endTime.Equals("20:00"))
				{
					timeEnd = 20;
				}
				else if (endTime.Equals("21:00"))
				{
					timeEnd = 21;
				}
				else if (endTime.Equals("22:00"))
				{
					timeEnd = 22;
				}
				else if (endTime.Equals("23:00"))
				{
					timeEnd = 23;
				}
				else if (endTime.Equals("00:00"))
				{
					timeEnd = 0;
				}
			}

			/* Define selected columns row */
			String sqlColumns = "";
			foreach (var item in listColumns)
			{
				if (item.Key.Contains("department"))
				{

					sqlColumns = sqlColumns + ", ba_reports_iapi.get_abonent_group(abonent_id) as " + @"""" + item.Value + @"""";
				}
				else if (item.Key.Contains("phone"))
				{
					/* Phone ID IS defined */
					if (_subsID != null)
					{
						sqlColumns = sqlColumns + ", at.phone as " + @"""" + item.Value + @"""";
					}
					/* Department group */
					else if (_depGroupID != null)
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_phone_list_by_abonent(abonent_id) as " + @"""" + item.Value + @"""";
					}
					/* Account group */
					else
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_phone_list_by_abonent_acc(abonent_id, account) as " + @"""" + item.Value + @"""";
					}
				}
				else if (item.Key.Contains("compensation_group"))
				{
					/* Phone ID IS defined */
					if (_subsID != null)
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_comp_by_phone(phone_id) as " + @"""" + item.Value + @"""";
					}
					/* Department group */
					else if (_depGroupID != null)
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_comp_by_abonent(abonent_id) as " + @"""" + item.Value + @"""";
					}
					/* Account group */
					else
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_comp_by_abonent_acc(abonent_id, account) as " + @"""" + item.Value + @"""";
					}
				}
				else if (item.Key.Contains("tarif"))
				{
					/* Phone ID IS defined */
					if (_subsID != null)
					{
						sqlColumns = sqlColumns + ", at.tarif as " + @"""" + item.Value + @"""";
					}
					/* Department group */
					else if (_depGroupID != null)
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_tarifs_by_abonent(abonent_id) as " + @"""" + item.Value + @"""";
					}
					/* Account group */
					else
					{
						sqlColumns = sqlColumns + ", ba_reports_iapi.get_tarifs_by_abonent_acc(abonent_id,account) as " + @"""" + item.Value + @"""";
					}
				}
				else
				{
					sqlColumns = sqlColumns + ", at." + item.Key + " as " + @"""" + item.Value + @"""";
				}
			}
			/* Remove first symbols */
			sqlColumns = sqlColumns.Remove(0, 2);

			/* Define query */

			/* Check if service is defined*/

			var oCom = new OracleCommand();
			oCom.CommandType = CommandType.Text;
			oCom.BindByName = true;

			/* Subscriber IS defined */
			if (_subsID != null)
			{
				oCom.CommandText =
					"SELECT " + sqlColumns + (@" FROM
						(SELECT nvl(a.name, '') as abonent_name,
							 t.abonent_id as abonent_id,
							 t.service_name as service_type,
							 nvl(a.email, '') as email,
							 decode(a.roles_id,
								  1,
								  '',
								  '') as user_role,
								  nvl(a.post, '') as post,
								  nvl(t.sum_add,0) as sum_add,
								  nvl(t_all.sum_add,0) as abonent_summ_add,
							 nvl(t.phone, '') as phone,
							 t.phone_id as phone_id,
							 nvl(t.tarif_name, '') as tarif,
							 nvl(t.account_name, '') as account
					  FROM 
							 (SELECT p.abonent_id,
									 a.service_name,
									 sum(a.cost) as sum_add, 
									 p.phone as phone, 
									 p.id as phone_id, 
									 p.tarif as tarif_name, 
									 p.account as account_name
							  FROM v_ba_calls a,
								   v_ba_phones p
							  WHERE a.phones_id = p.id and 

									p.id = :phone_id and

									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id,a.service_name,p.phone,p.id,p.tarif,p.account) t,
							  v_ba_abonents a,
							  (SELECT p.abonent_id,
									 sum(a.cost) as sum_add, 
									 p.phone as phone, 
									 p.id as phone_id, 
									 p.tarif as tarif_name, 
									 p.account as account_name
							   FROM v_ba_calls a,v_ba_phones p
							   WHERE a.phones_id = p.id and 

									p.id = :phone_id and

									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id,p.phone,p.id,p.tarif,p.account) t_all
					  WHERE t.abonent_id = a.id and 
							t_all.abonent_id = a.id
					  ORDER BY abonent_summ_add desc)at");

				oCom.Parameters.Add("phone_id", OracleDbType.Int64, _subsID, ParameterDirection.Input);

				oCom.Parameters.Add("time_start", OracleDbType.Int32, timeStart, ParameterDirection.Input);
				oCom.Parameters.Add("time_end", OracleDbType.Int32, timeEnd, ParameterDirection.Input);
				oCom.Parameters.Add("start_DoW", OracleDbType.Varchar2, startDoW, ParameterDirection.Input);
				oCom.Parameters.Add("end_DoW", OracleDbType.Varchar2, endDoW, ParameterDirection.Input);
				oCom.Parameters.Add("start_date", OracleDbType.Varchar2, dateStart, ParameterDirection.Input);
				oCom.Parameters.Add("end_date", OracleDbType.Varchar2, dateEnd, ParameterDirection.Input);
			}
			else
			{
				/* Department group */
				if (_depGroupID != null)
				{
					oCom.CommandText =
						"SELECT " + sqlColumns + (@" FROM
						(SELECT nvl(a.name, '') as abonent_name,
							 t.abonent_id as abonent_id,
							 t.service_name as service_type,
							 nvl(a.email, '') as email,
							 decode(a.roles_id,
								  1,
								  '',
								  '') as user_role,
								  nvl(a.post, '') as post,
								  nvl(t.sum_add,0) as sum_add,
								  nvl(t_all.sum_add,0) as abonent_summ_add
					  FROM 
							 (SELECT p.abonent_id,
									 a.service_name,
									 sum(a.cost) as sum_add 
							  FROM v_ba_calls a,
								   v_ba_phones p, 

								   table(ba_reports_iapi.get_allabonents_by_group(:org_id)) t

							  WHERE a.phones_id = p.id and 
									p.abonent_id = t.n and
									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id,a.service_name) t,
							  v_ba_abonents a,
							  (SELECT p.abonent_id,
									 sum(a.cost) as sum_add
							   FROM v_ba_calls a,
									v_ba_phones p, 

									table(ba_reports_iapi.get_allabonents_by_group(:org_id)) t

							   WHERE a.phones_id = p.id and 
									p.abonent_id = t.n and
									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id) t_all
					  WHERE t.abonent_id = a.id and 
							t_all.abonent_id = a.id
					  ORDER BY abonent_summ_add desc)at");

					oCom.Parameters.Add("org_id", OracleDbType.Int64, _depGroupID, ParameterDirection.Input);

					oCom.Parameters.Add("time_start", OracleDbType.Int32, timeStart, ParameterDirection.Input);
					oCom.Parameters.Add("time_end", OracleDbType.Int32, timeEnd, ParameterDirection.Input);
					oCom.Parameters.Add("start_DoW", OracleDbType.Varchar2, startDoW, ParameterDirection.Input);
					oCom.Parameters.Add("end_DoW", OracleDbType.Varchar2, endDoW, ParameterDirection.Input);
					oCom.Parameters.Add("start_date", OracleDbType.Varchar2, dateStart, ParameterDirection.Input);
					oCom.Parameters.Add("end_date", OracleDbType.Varchar2, dateEnd, ParameterDirection.Input);

				}
				/* Account group */
				else
				{
					oCom.CommandText =
						"SELECT " + sqlColumns + (@" FROM
						(SELECT nvl(a.name, '') as abonent_name,
							 t.abonent_id as abonent_id,
							 t.service_name as service_type,
							 nvl(a.email, '') as email,
							 decode(a.roles_id,
								  1,
								  '',
								  '') as user_role,
							nvl(a.post, '') as post,
							nvl(t.sum_add,0) as sum_add,
							nvl(t_all.sum_add,0) as abonent_summ_add,
							t.account_name as account
					  FROM 
							 (SELECT p.abonent_id,
									 a.service_name,
									 sum(a.cost) as sum_add,
									 p.account as account_name
							  FROM v_ba_calls a,
								   v_ba_phones p
							  WHERE a.phones_id = p.id and 
									p.account = :account_id and
									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id,a.service_name,p.account) t,
							  v_ba_abonents a,
							  (SELECT p.abonent_id,
									 sum(a.cost) as sum_add,
									 p.account as account_name
							   FROM v_ba_calls a,
									v_ba_phones p
							   WHERE a.phones_id = p.id and 
									p.account = :account_id and
									extract(hour from cast(a.call_date as timestamp)) between :time_start and :time_end-1 and
									decode(to_char(a.call_date, 'D'),1,7,2,1,3,2,4,3,5,4,6,5,7,6) between :start_DoW and :end_DoW and
									TRUNC(a.call_date) between TO_DATE(:start_date,'dd.mm.yyyy') and TO_DATE(:end_date,'dd.mm.yyyy')
							  GROUP BY p.abonent_id,p.account) t_all
					  WHERE t.abonent_id = a.id and 
							t_all.abonent_id = a.id
					  ORDER BY abonent_summ_add desc)at");
					oCom.Parameters.Add("account_id", OracleDbType.Varchar2, _accGroupID, ParameterDirection.Input);
					oCom.Parameters.Add("time_start", OracleDbType.Int32, timeStart, ParameterDirection.Input);
					oCom.Parameters.Add("time_end", OracleDbType.Int32, timeEnd, ParameterDirection.Input);
					oCom.Parameters.Add("start_DoW", OracleDbType.Varchar2, startDoW, ParameterDirection.Input);
					oCom.Parameters.Add("end_DoW", OracleDbType.Varchar2, endDoW, ParameterDirection.Input);
					oCom.Parameters.Add("start_date", OracleDbType.Varchar2, dateStart, ParameterDirection.Input);
					oCom.Parameters.Add("end_date", OracleDbType.Varchar2, dateEnd, ParameterDirection.Input);
				}
			}

			/* Getting data */
			return OracleDbPull.GetDataTable<ReportByEmp>(
				oCom,
				(resultDataTable, serviceResult) =>
				{
					/* Output report data */

					/* Final output structure */
					var reportDict = new ReportByEmp();

					/* List of record values list */

					var recordValues = new List<List<Object>>();

					/* List of columns */
					var columnList = new List<String>();

					/* Column values for all records */
					foreach (DataRow dr in resultDataTable.Rows)
					{
						/* Values of current row */
						var currRecordValues = new List<Object>();
						//for (int i = 0; i < reportResult.Columns.Count; i++)
						foreach (DataColumn dc in resultDataTable.Columns)
						{
							/* Value of current column */
							Object recordValue = dr[dc];
							if (recordValue is DBNull)
							{
								currRecordValues.Add("");
							}
							else
							{
								currRecordValues.Add(recordValue);
							}
						}
						recordValues.Add(currRecordValues);
					}


					/* Define list of column names */

					for (int i = 0; i < resultDataTable.Columns.Count; i++)
					{
						var columnName = resultDataTable.Columns[i].ColumnName;
						columnList.Add(columnName.ToString());
					}

					/* Define output structure */
					reportDict.ColumnNames = columnList;
					reportDict.AbonentReportData = recordValues;

					serviceResult.DataOrNullOrDefValue = reportDict;
				}
				);

			#endregion
		}
	}
}