﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!



using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Reflection;
using System.Web;

namespace BillAnalyserWebApp.Code.Data
{
	public static class DetailCalls
	{
		public static List<DetailCallAttributes> _listDetailed = new List<DetailCallAttributes>();
		public static long _numberCallsForInsert;
		public static string numberPhone;
		public static string tariff;
		public static string personalBill;
	}

	/// <summary>
	/// Пока наполняется только методом <see cref="ImportFilesService.UploadListServices"/>.
	/// </summary>
	public static class UploadServices
	{
		/// <summary>
		/// Пока наполняется только методом <see cref="ImportFilesService.UploadListServices"/>.
		/// </summary>
		public static List<ListServicesInfo> _listServices = new List<ListServicesInfo>();
		public static BillInfoAttributes _currentBill;
		public static bool _replaceService;
	}

	[Obfuscation(Exclude = true)]
	public class BillInfoAttributes
	{
		// Начало расчетного периода
		public DateTime ReportBSd { get; set; }
		// Конец расчетного периода
		public DateTime ReportBEd { get; set; }
		// Номер импортируемого счета
		public string ReportBBn { get; set; }
		// Номер лицевого счета
		public string ReportBAn { get; set; }

		public Int64 ImportKey { get; set; }

		private Int64 _id = -1;

		public BillInfoAttributes()
		{
		}

		public BillInfoAttributes(BillInfoAttributes from)
		{
			_id = from._id;
			ReportBAn = from.ReportBAn;
			ReportBBn = from.ReportBBn;
			ReportBEd = from.ReportBEd;
			ReportBSd = from.ReportBSd;
		}

		public Int64 ID
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}
	}

	[Obfuscation(Exclude = true)]
	public class ServiceAttributes
	{
		/// <summary>
		/// Наименование услуги
		/// </summary>
		public string report_tp_n;
        
		/// <summary>
		/// Длительность и ед.измерения услуги
		/// </summary>
		public string report_tp_c;

		/// <summary>
		/// Сумма за услугу без НДС
		/// </summary>
		public string report_tp_awt;

		/// <summary>
		/// Сумма за услугу с НДС
		/// </summary>
		public string report_tp_a;

        /// <summary>
        /// Сумма скидки offline  без НДС
        /// </summary>
        public string report_tp_od_awt;

        /// <summary>
        /// Сумма скидка offline с НДС
        /// </summary>
        public string report_tp_od_a;

		/// <summary>
		/// Тип услуги: 1 - периодическая, 0 - не периодическая
		/// </summary>
		//public int typeService;
	}

	[Obfuscation(Exclude = true)]
	public class ListServicesInfo
	{
		/// <summary>
		/// Телефонный номер
		/// </summary>
		public String _numberPhone;

		/// <summary>
		/// Отчетный период
		/// </summary>
		public DateTime _period;

		/// <summary>
		/// Название тарифа
		/// </summary>
		public String _nameTarif;

		/// <summary>
		/// Список периодических услуг
		/// </summary>
		public List<ServiceAttributes> _listPeriodicalServices;

		/// <summary>
		/// Список непериодических услуг
		/// </summary>
		public List<ServiceAttributes> _listNotPeriodicalServices;
	}

	[Obfuscation(Exclude = true)]
	public class DetailCallAttributes
	{
		/// <summary>
		/// Дата начала периода, за которым закреплена запись этой детализации.
		/// Реальное действие (разговор, смс и т.д.) может произойти до начала периода.
		/// </summary>
		public DateTime period_start_date;

		/// <summary>
		/// Дата звонка 
		/// </summary>
		public string report_ds_i_d;

		/// <summary>
		/// Время звонка
		/// </summary>
		public string report_ds_i_t;

		/// <summary>
		/// Абонент B (если звонок входящий то -- +7XXXXX)
		/// </summary>
		// Абонент B (если звонок входящий то <-- +7XXXXX)
		public string report_ds_i_n;

		/// <summary>
		/// Зона связи предприятия (роуминг)
		/// </summary>
		public string report_ds_i_zp;

		/// <summary>
		/// Зона внешней телефонной компании(Международ.разговоры)
		/// </summary>
		public string report_ds_i_zv;

		/// <summary>
		/// Услуга
		/// </summary>
		public string report_ds_i_s;

		/// <summary>
		/// Длительность
		/// </summary>
		public string report_ds_i_du;

		/// <summary>
		/// Стоимость без НДС
		/// </summary>
		public string report_ds_i_с;

		/// <summary>
		/// Длительность звонка для тарификации
		/// </summary>
		public string report_ds_i_dup;

		/// <summary>
		/// Стоимость с НДС
		/// </summary>
		public string report_ds_i_f;

		/// <summary>
		/// Ставка НДС
		/// </summary>
		public double factor_nds;

		public int ID;

	}

	[Obfuscation(Exclude = true)]
	public class DetailCallAttributesCsv
	{
		/// <summary>
		/// Номер А
		/// </summary>
		public string number_a;

		/// <summary>
		/// Дата звонка 
		/// </summary>
		public DateTime date_call;

		/// <summary>
		/// Величина
		/// </summary>
		public string dur;

		/// <summary>
		/// Абонент B (если звонок входящий то -- +7XXXXX)
		/// </summary>
		// Абонент B (если звонок входящий то <-- +7XXXXX)
		public string number_b;

		/// <summary>
		/// Тип: исходящий (I), входящий(O)
		/// </summary>
		public string type_call;

		/// <summary>
		/// Зона связи-роуминг
		/// </summary>
		public string rouming_zone;

		/// <summary>
		/// Зона внешней телефонной компании(Международ.разговоры)
		/// </summary>
		public string international_zone;

		/// <summary>
		/// Услуга
		/// </summary>
		public string service_name;

		/// <summary>
		/// Стоимость без НДС
		/// </summary>
		public string cost;

		/// <summary>
		/// Ставка НДС
		/// </summary>
		public double factor_nds;

		private Int64 _id = -1;

		public DetailCallAttributesCsv()
		{
		}

		public Int64 ID
		{
			get
			{
				return _id;
			}
			set
			{
				_id = value;
			}
		}
	}

	[Obfuscation(Exclude = true)]
	public class ResultInsertCalls
	{
		public string NumberPhone { get; set; }
		public int CountSucceffulInsertedCalls { get; set; }
		public int CountUnsucceffulInsertedCalls { get; set; }
		public int CountAlreadyInserted { get; set; }
	}
}