﻿using System;
using System.Data;
using BillAnalyserWebApp.Code.IFlex.DB.Oracle;
using CrossCompileSharing.Data;

namespace BillAnalyserWebApp.Code.IFlex.DB
{
	public class DbResult
	{
		private BusinessError _businessError = new BusinessError();
		public BusinessError BusinessError
		{
			get { return _businessError; }
		}

		private Exception _dataException;
		public Exception DataException
		{
			get { return _dataException; }
		}

		public DataTable DataTable { get; set; }
		public DataSet DataSet { get; set; }

		public Boolean IsDone
		{
			get
			{
				return BusinessError.HasErrors == false;
			}
		}

		public void SetDataExceptionAndBusinessError<TResultType>(Exception dataException, ServiceResult<TResultType> serviceResult)
		{
			_dataException = dataException;
			_businessError = BusinessErrorManager.ExtractIfExistOrMakeAsDefaultDbError(dataException);
			serviceResult.BusinessErrorNotNulled.Add(_businessError);
		}
	}
}
