﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Web;
using System.Web.Services;

namespace BillAnalyserWebApp
{
	/// <summary>
	/// Summary description for $codebehindclassname$
	/// </summary>
// ReSharper disable InconsistentNaming
	[Obfuscation(Exclude = true)]
	public class FileManager : IHttpHandler
// ReSharper restore InconsistentNaming
	{
		static readonly Dictionary<String, FileInfo> _files = new Dictionary<string, FileInfo>();

		public static FileInfo GetFileInfo(String fileUniqueKey)
		{
			lock (_files)
			{
				return _files.ContainsKey(fileUniqueKey) ? _files[fileUniqueKey] : null;
			}
		}

		public static void DeleteFile(string fileUniqueKey)
		{
			FileInfo fileInfo;
			lock (_files)
			{
				fileInfo = _files.ContainsKey(fileUniqueKey) ? _files[fileUniqueKey] : null;
				if (fileInfo == null)
				{
					return;
				}

				_files.Remove(fileUniqueKey);
			}

			fileInfo.Refresh();
			if (fileInfo.Exists)
			{
				fileInfo.Delete();
			}
		}

		public void ProcessRequest(HttpContext context)
		{
			var binaryReader = new BinaryReader(context.Request.InputStream);

			var tempFileInfo = new FileInfo(Path.GetTempFileName());
			using (var fileStream = tempFileInfo.OpenWrite())
			{
				// Создадим пустой файл, чтоб писать в него потом частями асинхронно.
				for (var i = 0; i < context.Request.InputStream.Length; i++)
				{
					fileStream.WriteByte(binaryReader.ReadByte());
				}
			}

			var fileUniqueKey = Guid.NewGuid().ToString("N");
			lock (_files)
			{
				_files.Add(fileUniqueKey, tempFileInfo);
			}

			context.Response.ContentType = "text/plain";
			context.Response.Write(fileUniqueKey);
		}

		public bool IsReusable
		{
			get
			{
				return false;
			}
		}
	}
}
