﻿using System;
using System.Web;
using BillAnalyserWebApp.Code.Data;
using BillAnalyserWebApp.Code.Log;
using CrossCompileSharing.Log;

namespace BillAnalyserWebApp
{
	/// <summary>
	/// Класс представляющий приложение ASP.NET.
	/// </summary>
	[System.Reflection.Obfuscation(Exclude = true)]
	public class Global : HttpApplication
	{
		public static event Action End;

		private static void InvokeEnd()
		{
			var action = End;
			if (action != null)
			{
				action();
			}
		}

		protected void Application_Start(object sender, EventArgs e)
		{
			Logger.InitLogger(new AspNetLogProvider());

			SmtpMailTemplate.PrepareMailTemplate();
		}

		protected void Application_BeginRequest(object sender, EventArgs e)
		{

		}

		protected void Application_Error(object sender, EventArgs e)
		{
			Logger.Write(
				Server.GetLastError()
				);
		}

		protected void Application_End(object sender, EventArgs e)
		{
			InvokeEnd();
		}
	}
}