﻿// Создал Андрей Котов. Любые изменения вносимые вами должны быть помечены комментарием идентифицирующим вас и ваши действия!



using System;
using System.Data;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using BillAnalyserWebApp.Code.Data;
using BillAnalyserWebApp.Code.IFlex.DB;
using CrossCompileSharing.Data;
using iFlexBillAnalyserResources.Data;
using Oracle.DataAccess.Client;

namespace BillAnalyserWebApp
{
	[ServiceContract(Namespace = "iFlexSettingsService")]
	[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
	public class SettingsService
	{
		[OperationContract]
		public ServiceResult<List<AnalyserSetting>> GetSettingGroups()
		{
			return AnalyserSettings.SettingGroupsGet();
		}

		[OperationContract]
        public ServiceResult<GetSettingsResult> GetSettings(Int64 parentId)
		{
			return AnalyserSettings.SettingsGet(parentId);
		}

		[OperationContract]
		public ServiceResult<List<String>> GetEnumValue(Int64 id)
		{
			return AnalyserSettings.GetListValue(id);
		}

		[OperationContract]
        public ServiceResult<SetSettingsValueResult> SetValue(Int64 id, double? vn, String vv, DateTime? vd)
		{
			return AnalyserSettings.SetValue(id, vn, vv, vd);
		}

		/// <summary>
		/// it3xl.ru добавил метод получения всех периодов (Billing Periods) которые уже есть в программе
		/// </summary>
		[OperationContract]
		public ServiceResult<List<BillingPeriod>> GetAllBillingPeriods()
		{
			return AllBillingPeriods.GetAllBillingPeriods();
		}

		/// <summary>
		/// it3xl.ru: Получение версии базы данных.
		/// </summary>
		[OperationContract]
		public ServiceResult<String> GetDbVersion()
		{
			var oCom = new OracleCommand
			{
				CommandText = @"begin :outP := krn_setting_iapi.get_v(:inpP); end;",
			};
			oCom.Parameters.Add("outP", OracleDbType.Varchar2, 100, null, ParameterDirection.Output);
			oCom.Parameters.Add("inpP", OracleDbType.Varchar2, "version", ParameterDirection.Input);
			var result = OracleDbPull.ExecuteNonQuery<String>(
				oCom,
				res=>
					{
						res.DataOrNullOrDefValue = oCom.Parameters[0].Value.ToString();
					}
				);

			return result;
		}
	}
}